#!/usr/bin/perl
###############################################################################
#    DrakSec - Lib
#
#   DrakSec Webmin Module ver 0.
#    Copyright (C) 2001 by Franck Qulain
#    Bug reports to: shift@free.fr
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
###############################################################################
use CGI qw(:standard param);
do '../web-lib.pl';
&init_config();
$ver = "0.1";

###############################################################################
sub start {
###############################################################################
  &header($text{'draksec_title'}, undef);
  print "<hr>\n";
  print "<table border width=100%>\n";
  print "<tr $tb> <td ><b>$text{'draksec_title'}</b></td></tr>\n";
  print startform qw(POST config.cgi);
  print "<tr $cb> <td>";
  print "<br>";
  print "<b>",$text{'draksec_select_level'}, " : </b><br><br>\n";
  &input_level;
  print "<input type=submit name=Ok value=", $text{'draksec_ok'}, ">";
  print "</td></tr></table>";
  print "<hr>\n";
  print  &text('draksec_version', $ver);
  print "<hr>\n";
  &footer("/", $text{'index'});
}
###############################################################################
sub get_current_level {
###############################################################################
  $current = "";
  # TODO
  return $current;
}
###############################################################################
sub input_level {
###############################################################################
  # $current = &get_current_level;
  $current = 3;
  $input = "";
  @levels =qw(0 1 2 3 4 5);
  for $level (@levels) {
       if ($level eq $current) {
         $checked = "checked";
       } else {
         $checked = "";
      }
      $input = $input."<input type=radio name=level value=$level $checked><b>".$text{"draksec_$level"}." : </b> ".$text{"draksec_desc_$level"}."<br><br>\n";
  }
 print $input;
}

###############################################################################
sub config {
###############################################################################
 $level = param("level");

 if ($level eq "") {
   &header($text{'draksec_error'}, undef);
   print "<hr>\n";
   print "<h3><font color=red>", &text('draksec_must_select_level') , "</font></h3>";
   print "<hr>\n";
   print &text('draksec_version', $ver);
   print "<hr>\n";
   &footer(".", $text{'draksec_return'});
 } else {
     &change_level($level);
 }
}
###############################################################################
sub change_level {
###############################################################################
  $level = shift;
  &header($text{'draksec_level'}, undef);
  print "<hr>\n";
  print "<h3>", &text('draksec_level_changing',$level), "</h3>";
  print "<hr>\n";
  # Todo : find another way to do that 'cause it is not very clear and erhaps secure :(
  $tempfile = tempname();
  system "/usr/sbin/msec $level  &> $tempfile";
  open(RSLT,$tempfile);
  while(<RSLT>) {
        print "$_<br>\n";
  }
  unlink($tempfile);
  print "<hr>\n";
  print &text('draksec_version', $ver);
  print "<br><hr>\n";
  &footer(".", $text{'draksec_return'});
}
###############################################################################
return 1;
###############################################################################
#                                    EOF                                      #
###############################################################################
